# SoRotateCylindricalDragger Class Reference
[Draggers]

`#include <Inventor/draggers/SoRotateCylindricalDragger.h>`

Inheritance diagram for SoRotateCylindricalDragger:

List of all members.

## Detailed Description

The SoRotateCylindricalDragger class is for rotating geometry around a single axis.

Here's how the dragger looks with it's default geometry in the inactive state:

Use an instance of this dragger class in your scenegraph to let the end-users of your application rotate geometry around a pre-defined axis vector in 3D.

For the dragger orientation and positioning itself, use some kind of transformation node in your scenegraph, as usual.

## Public Member Functions

| SoRotateCylindricalDragger (void)
void | setProjector (SbCylinderProjector *p)
const SbCylinderProjector * | getProjector (void) const

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFRotation | rotation

## Protected Member Functions

| ~SoRotateCylindricalDragger ()
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void | copyContents (const SoFieldContainer *fromfc, SbBool copyconnections)
void | dragStart (void)
void | drag (void)
void | dragFinish (void)

## Static Protected Member Functions

void | startCB (void *f, SoDragger *d)
void | motionCB (void *f, SoDragger *d)
void | doneCB (void *f, SoDragger *d)
void | fieldSensorCB (void *f, SoSensor *s)
void | valueChangedCB (void *f, SoDragger *d)

## Protected Attributes

SoFieldSensor * | fieldSensor
SbCylinderProjector * | cylinderProj
SbBool | userProj

## Constructor & Destructor Documentation

SoRotateCylindricalDragger::SoRotateCylindricalDragger | ( | void |  | ) |

Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Node kit structure (new entries versus parent class marked with arrow prefix):

      CLASS SoRotateCylindricalDragger
      -->"this"
            "callbackList"
            "topSeparator"
               "motionMatrix"
               "geomSeparator"
      -->         "rotatorSwitch"
      -->            "rotator"
      -->            "rotatorActive"
      -->         "feedbackSwitch"
      -->            "feedback"
      -->            "feedbackActive"

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

      CLASS SoRotateCylindricalDragger
      PVT   "this",  SoRotateCylindricalDragger  ---
            "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
      PVT   "topSeparator",  SoSeparator  ---
      PVT   "motionMatrix",  SoMatrixTransform  ---
      PVT   "geomSeparator",  SoSeparator  ---
      PVT   "rotatorSwitch",  SoSwitch  ---
            "rotator",  SoSeparator  ---
            "rotatorActive",  SoSeparator  ---
      PVT   "feedbackSwitch",  SoSwitch  ---
            "feedback",  SoSeparator  ---
            "feedbackActive",  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

SoRotateCylindricalDragger::~SoRotateCylindricalDragger | ( |  | ) | `[protected]`

| Protected destructor. (Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

## Member Function Documentation

void SoRotateCylindricalDragger::initClass | ( | void |  | ) | `[static]`

| Initializes type system for this dragger class. Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init(). Reimplemented from SoDragger.

void SoRotateCylindricalDragger::setProjector | ( | SbCylinderProjector * | p | ) |

Replace the default cylinder projection strategy. You may want to do this if you change the dragger geometry, for instance.

The default cylinder projection is an SbCylinderPlaneProjector.

See also:
  SbCylinderSectionProjector, SbCylinderSheetProjector

const SbCylinderProjector * SoRotateCylindricalDragger::getProjector | ( | void |  | ) | const

Returns projector instance used for converting from user interaction dragger movements to 3D dragger re-orientation.

See also:
  setProjector()

SbBool SoRotateCylindricalDragger::setUpConnections | ( | SbBool | onoff,
|  | SbBool | doitalways = FALSE
| ) | `[protected, virtual]`

| Sets up all internal connections for instances of this class. (This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.) Reimplemented from SoInteractionKit.

void SoRotateCylindricalDragger::copyContents | ( | const SoFieldContainer * | fromfc,
|  | SbBool | copyconnections
| ) | `[protected, virtual]`

Makes a deep copy of all data of from into this instance, except external scenegraph references if copyconnections is `FALSE`.

This is the protected method that should be overridden by extension node / engine / dragger / whatever subclasses which needs to account for internal data that are not handled automatically.

Note that for simply copying e.g. a node from application code, it should be sufficient to do:

      SoNode * mynewnode = templatenode->copy();

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to it's parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

      void
      MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
                                        SbBool copyconnections)
      {
        // let parent superclasses do their thing (copy fields, copy
        // instance name, etc etc)
        SoNode::copyContents(from, copyconnections);

        // [..then copy internal data..]
      }

Reimplemented from SoInteractionKit.

void SoRotateCylindricalDragger::startCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoRotateCylindricalDragger::motionCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoRotateCylindricalDragger::doneCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoRotateCylindricalDragger::fieldSensorCB | ( | void * | d,
|  | SoSensor * | s
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoInteractionKit.

void SoRotateCylindricalDragger::valueChangedCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoRotateCylindricalDragger::dragStart | ( | void |  | ) | `[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when dragger is selected (picked) by the user.

void SoRotateCylindricalDragger::drag | ( | void |  | ) | `[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when user drags the mouse after picking the dragger.

void SoRotateCylindricalDragger::dragFinish | ( | void |  | ) | `[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when mouse button is released after picking and interacting with the dragger.

## Member Data Documentation

SoSFRotation SoRotateCylindricalDragger::rotation

| This field is continuously updated to contain the rotation of the current direction vector of the dragger. The application programmer using this dragger in his scenegraph should connect the relevant node fields in the scene to this field to make them follow the dragger orientation.

SoFieldSensor * SoRotateCylindricalDragger::fieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoInteractionKit.

SbCylinderProjector * SoRotateCylindricalDragger::cylinderProj`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SbBool SoRotateCylindricalDragger::userProj`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoRotateCylindricalDragger.h
- SoRotateCylindricalDragger.cpp